// All code by Michael Angeletti

var $j = jQuery.noConflict();


$j('document').ready(function(){





	/********************************************
	
	Load time operations
	
	********************************************/
	
	// get cart
	
	cart = getCartInstance();
	
	// update form fields and fill them back in
	
	update_form_fields();
	complete_form_fields();
	display_query_errors();
	
	// display cart if there are items
	
	if(cart.items && cart.items.length > 0)
	{
		display_cart();
	}
	
	// old order form submit attempt
	
	$j('form[action$=cgi-bin/UCEditor]').submit(function(event){
		event.preventDefault();
		if($j(this).find('[name=quantity]').val())
		{
			add_item_to_cart($j(this).find('[name=add]').val(), Number($j(this).find('[name=quantity]').val()));
		}
		else
		{
			add_item_to_cart($j(this).find('[name=add]').val(), 1);
		}
	});
	
	// estimate shipping and list options after customer blurs shipping zip code field
	
	var estimate_shipping_timeout;
	
	$j('.estimate_shipping').change(function(){
		try
		{
			window.clearTimeout(estimate_shipping_timeout);
		}
		catch(e)
		{
			// first pass - do nothing
		}
		estimate_shipping_timeout = window.setTimeout(capture_form_and_list_shipping, 1500);
	});
	$j('.estimate_shipping').keypress(function(){
		try
		{
			window.clearTimeout(estimate_shipping_timeout);
		}
		catch(e)
		{
			// first pass - do nothing
		}
		estimate_shipping_timeout = window.setTimeout(capture_form_and_list_shipping, 1500);
	});
	
	// change selection link clicked
	
	$j('#j_change_selection').click(function(event){
		event.preventDefault();
		clear_cart();
	});
	
	// update cart
	
	$j('#j_update_cart').click(function(event){
		event.preventDefault();
		display_cart();
	});
	
	// finalize order pressed
	
	$j('.j_order').submit(function(event){
		event.preventDefault();
		capture_form_fields();
		attempt_order();
	});
	
	// cvv link
	
	$j('.j_cvv_help_link a').click(function(event){
		event.preventDefault();
		window.open($j(this).attr('href'), 'cvv', 'width=650,height=400');
	});
	
	// toggle billing fields
	
	toggle_billing_fields();
	
	$j('[name=billingsameasshipping]').click(function(){
		toggle_billing_fields();
	});
	
	
	
	
	
	/********************************************
	
	Functions
	
	********************************************/
	
	// toggle billing fields
	
	function toggle_billing_fields()
	{
		try
		{
			if($j('[name=billingsameasshipping]')[0].checked == true)
			{
				$j('dl.billing').hide(250);
				$j('#billing_must_match_message').show();
			}
			else
			{
				$j('dl.billing').show(250);
				$j('#billing_must_match_message').hide();
			}
		}
		catch(e)
		{
			handle_error('toggle_billing_fields()', e);
		}
	}
	
	
	
	
	
	// handle error
	
	function handle_error(message, error)
	{
		try
		{
			logError(message + ' : ' + error);
		}
		catch(e)
		{
			alert('An error has occured. Please refresh your browser.\n\n\nError: ' + message + ' : ' + error);
		}
	}
	
	
	
	
	
	// update item quantities
	
	function update_quantity(itemId, quantity)
	{
		try
		{
			var quantity = Number(quantity);
			var itemArray = [];
			if(cart.items && cart.items.length > 0)
			{
				for(var i = 0; i < cart.items.length; i ++)
				{
					if(cart.items[i].itemId !== itemId)
					{
						itemArray[itemArray.length] = {itemId: cart.items[i].itemId, quantity: cart.items[i].quantity};
					}
					else
					{
						itemArray[itemArray.length] = {itemId: itemId, quantity: quantity};
					}
				}
			}
			var errors = updateItems(itemArray);
			if(errors !== null && errors.length > 0)
			{
				display_cart_errors(errors);
			}
			else
			{
				if(cart.items && cart.items.length > 0)
				{
					display_cart();
				}
				else
				{
					hide_cart();
				}
			}
		}
		catch(e)
		{
			handle_error('update_quantity()', e);
		}
	}
	
	
	
	
	
	// pupulate cart table
	
	function populate_cart_table()
	{
		try
		{
			var data = {};
			data.products = [];
			if(cart.items !== null && cart.items.length > 0)
			{
				var items_to_get = [];
				for(var i = 0; i < cart.items.length; i ++)
				{
					items_to_get[items_to_get.length] = cart.items[i].itemId;
				}
				var items = getItems(items_to_get);
				for(var i = 0; i < cart.items.length; i ++)
				{
					data.products.push({
						id: cart.items[i].itemId,
						quantity: cart.items[i].quantity,
						total: eval(cart.items[i].quantity * cart.items[i].unitCost).toFixed(2),
						description: cart.items[i].description,
						thumbnail_url: get_thumbnail_url(items, cart.items[i].itemId),
						contents: get_attribute(cart.items[i], 'contents')
					});
				}
			}
			$j('#cart_tbody').setTemplate($j('#cart_table_template').val().replace('<!--', '').replace('-->', ''), null, {filter_data: false});
			$j('#cart_tbody').processTemplate(data);
			$j('[name^=ADD_]').keypress(function(event){
				var code = (event.keyCode ? event.keyCode : event.which);
				if(code == 13)
				{
					event.preventDefault();
					update_quantity($j(this).attr('name').slice(4), $j(this).val());
				}
			});
			$j('[name^=ADD_]').change(function(){
				update_quantity($j(this).attr('name').slice(4), $j(this).val());
			});
			$j('[title^=REMOVE_]').click(function(event){
				event.preventDefault();
				var errors = removeItem($j(this).attr('title').slice(7));
				if(errors !== null && errors.length > 0)
				{
					display_cart_errors(errors);
				}
				else
				{
					if(cart.items && cart.items.length > 0)
					{
						display_cart();
					}
					else
					{
						hide_cart();
					}
				}
			});
		}
		catch(e)
		{
			handle_error('populate_cart_table()', e);
		}
	}
	
	
	
	
	
	// add items to cart
	
	function add_item_to_cart(itemId, quantity)
	{
		try
		{
			var errors = addItems([{itemId: itemId, quantity: quantity}]);
			if(errors !== null && errors.length > 0)
			{
				display_cart_errors(errors);
			}
			else
			{
				display_cart();
			}
		}
		catch(e)
		{
			handle_error('add_item_to_cart()', e);
		}
	}
	
	
	
	
	
	// clear cart
	
	function clear_cart()
	{
		try
		{
			clearItems();
			hide_cart();
		}
		catch(e)
		{
			handle_error('clear_cart()', e);
		}
	}
	
	
	
	
	
	// display cart errors
	
	function display_cart_errors(errors)
	{
		try
		{
			var data = {};
			data.errors = [];
			for(var i = 0; i < errors.length; i ++)
			{
				data.errors[data.errors.length] = errors[i];
			}
			// render template
			$j('#j_errors_wrap').setTemplate($j('#cart_errors_template').val().replace('<!--', '').replace('-->', ''), null, {filter_data: false});
			$j('#j_errors_wrap').processTemplate(data);
			$j('#j_errors_wrap').show();
			$j('html,body').animate({scrollTop: $j('#j_errors_wrap').offset().top}, 1000);
		}
		catch(e)
		{
			handle_error('display_cart_errors()', e);
		}
	}
	
	
	
	
	
	// display query errors
	
	function display_query_errors()
	{
		try
		{
			var errors = getParameterValues("error");
			
			if(errors != null && errors.length > 0)
			{
				display_cart_errors(errors);
			}		
		}
		catch(e)
		{
			handle_error('display_query_errors()', e);
		}
	}
	
	
	
	
	
	// display cart
	
	function display_cart()
	{
		try
		{
			$j('#j_errors_wrap').hide();
			populate_cart_table();
			list_shipping_options();
			display_cart_totals();
			$j('.shell_wrap').show(250);
			$j('html,body').animate({scrollTop: $j('#shell_wrap').offset().top}, 1000);
			$j('.hide_when_cart_present').hide();
		}
		catch(e)
		{
			handle_error('display_cart()', e);
		}
	}
	
	
	
	
	
	// hide cart
	
	function hide_cart()
	{
		try
		{
			$j('#j_errors_wrap').hide();
			$j('.shell_wrap').hide(500);
			$j('html,body').animate({scrollTop: $j('document').offset().top}, 1500);
			$j('.hide_when_cart_present').show();
		}
		catch(e)
		{
			handle_error('hide_cart()', e);
		}
	}
	
	
	
	
	
	// get attribute
	
	function get_attribute(itemObj, attrName)
	{
		try
		{
			if(itemObj.attributes)
			{
				for(var i = 0; i < itemObj.attributes.length; i ++)
				{
					if(itemObj.attributes[i].name == attrName)
					{
						return itemObj.attributes[i].value;
					}
				}
			}
		}
		catch(e)
		{
			handle_error('get_attribute()', e);
		}
		return '';
	}
	
	
	
	
	
	// get thumbnail url
	
	function get_thumbnail_url(items, itemId)
	{
		try
		{
			for(var i = 0; i < items.length; i ++)
			{
				if(items[i].itemId === itemId && items[i].multimedias && items[i].multimedias.length > 0 && items[i].multimedias[0].thumbnails && items[i].multimedias[0].thumbnails.length > 0)
				{
					return items[i].multimedias[0].thumbnails[0].httpUrl;
				}
			}
		}
		catch(e)
		{
			handle_error('get_thumbnail_url()', e);
		}
		return '';
	}
	
	
	
	
	
	// display form fields
	
	function update_form_fields()
	{
		try
		{
			
			var allowed_countries = getAllowedCountries();
			var allowed_countries_html = '';
			for(var i = 0; i < allowed_countries.length; i ++)
			{
				allowed_countries_html += '<option>' + allowed_countries[i] + '</option>';
			}
			$j('[name=shippingcountry]').html(allowed_countries_html);
			$j('[name=billingcountry]').html(allowed_countries_html);
			if(cart.shipToCountry)
			{
				$j('[name=shippingcountry]').val(cart.shipToCountry);
			}
			else
			{
				$j('[name=shippingcountry]').val('United States');
			}
			if(cart.billToCountry)
			{
				$j('[name=billingcountry]').val(cart.billToCountry);
			}
			else
			{
				$j('[name=billingcountry]').val('United States');
			}
			update_states($j('[name=billingcountry]').val(), $j('[name=billingstate]'));
			update_states($j('[name=shippingcountry]').val(), $j('[name=shippingstate]'));
			$j('[name=shippingcountry]').change(function(event){
				$j('[name=shippingcountry]').blur(function(event){
					update_states($j('[name=shippingcountry]').val(), $j('[name=shippingstate]'));
				});
			});
			$j('[name=billingcountry]').change(function(event){
				$j('[name=billingcountry]').blur(function(event){
					update_states($j('[name=billingcountry]').val(), $j('[name=billingstate]'));
				});
			});
		}
		catch(e)
		{
			handle_error('update_form_fields()', e);update_states
		}
	}
	
	
	
	
	
	// update states / provinces
	
	function update_states(country, element)
	{
		try
		{
			var states = getStateProvinces(country);
			if(states !== null && states.length > 0)
			{
				var states_html = '';
				for(var i = 0; i < states.length; i ++)
				{
					states_html += '<option>' + states[i] + '</option>';
				}
				if(element.attr('class') == 'estimate_shipping')
				{
					element.replaceWith('<select id="' + element.attr('id') + '" class="estimate_shipping" name="' + element.attr('name') + '">' + states_html + '</select>');
				}
				else
				{
					element.replaceWith('<select id="' + element.attr('id') + '" name="' + element.attr('name') + '">' + states_html + '</select>');
				}
			}
			else
			{
				if(element.attr('class') == 'estimate_shipping')
				{
					element.replaceWith('<input id="' + element.attr('id') + '" type="text" class="j_text estimate_shipping" name="' + element.attr('name') + '" />');
				}
				else
				{
					element.replaceWith('<input id="' + element.attr('id') + '" type="text" class="j_text" name="' + element.attr('name') + '" />');
				}
			}
		}
		catch(e)
		{
			handle_error('update_states()', e);
		}
	}
	
	
	
	
	
	// complete form fields
	
	function complete_form_fields()
	{
		try
		{
			// states
			
			var us_states = [
				{code: 'AL', state: 'Alabama'},
				{code: 'AK', state: 'Alaska'},
				{code: 'AS', state: 'American Samoa'},
				{code: 'AZ', state: 'Arizona'},
				{code: 'AR', state: 'Arkansas'},
				{code: 'Armed Forces Africa', state: 'Armed Forces Africa'},
				{code: 'Armed Forces Americas', state: 'Armed Forces Americas'},
				{code: 'Armed Forces Canada', state: 'Armed Forces Canada'},
				{code: 'Armed Forces Europe', state: 'Armed Forces Europe'},
				{code: 'Armed Forces Middle East', state: 'Armed Forces Middle East'},
				{code: 'Armed Forces Pacific', state: 'Armed Forces Pacific'},
				{code: 'CA', state: 'California'},
				{code: 'CO', state: 'Colorado'},
				{code: 'CT', state: 'Connecticut'},
				{code: 'DE', state: 'Delaware'},
				{code: 'DC', state: 'District of Columbia'},
				{code: 'FM', state: 'Federated States of Micronesia'},
				{code: 'FL', state: 'Florida'},
				{code: 'GE', state: 'Georgia'},
				{code: 'GU', state: 'Guam'},
				{code: 'HI', state: 'Hawaii'},
				{code: 'ID', state: 'Idaho'},
				{code: 'IL', state: 'Illinois'},
				{code: 'IN', state: 'Indiana'},
				{code: 'IA', state: 'Iowa'},
				{code: 'KS', state: 'Kansas'},
				{code: 'KY', state: 'Kentucky'},
				{code: 'LA', state: 'Louisiana'},
				{code: 'ME', state: 'Maine'},
				{code: 'MH', state: 'Marshall Islands'},
				{code: 'MD', state: 'Maryland'},
				{code: 'MA', state: 'Massachusetts'},
				{code: 'MI', state: 'Michigan'},
				{code: 'MT', state: 'Minnesota'},
				{code: 'MS', state: 'Mississippi'},
				{code: 'MO', state: 'Missouri'},
				{code: 'MT', state: 'Montana'},
				{code: 'NE', state: 'Nebraska'},
				{code: 'NV', state: 'Nevada'},
				{code: 'NH', state: 'New Hampshire'},
				{code: 'NJ', state: 'New Jersey'},
				{code: 'NM', state: 'New Mexico'},
				{code: 'NY', state: 'New York'},
				{code: 'NC', state: 'North Carolina'},
				{code: 'ND', state: 'North Dakota'},
				{code: 'MP', state: 'Northern Mariana Islands'},
				{code: 'OH', state: 'Ohio'},
				{code: 'OK', state: 'Oklahoma'},
				{code: 'OR', state: 'Oregon'},
				{code: 'PW', state: 'Palau'},
				{code: 'PA', state: 'Pennsylvania'},
				{code: 'PR', state: 'Puerto Rico'},
				{code: 'RI', state: 'Rhode Island'},
				{code: 'SC', state: 'South Carolina'},
				{code: 'SD', state: 'South Dakota'},
				{code: 'TN', state: 'Tennessee'},
				{code: 'TX', state: 'Texas'},
				{code: 'UT', state: 'Utah'},
				{code: 'VT', state: 'Vermont'},
				{code: 'VI', state: 'Virgin Islands'},
				{code: 'VA', state: 'Virginia'},
				{code: 'WA', state: 'Washington'},
				{code: 'WV', state: 'West Virginia'},
				{code: 'WI', state: 'Wisconsin'},
				{code: 'WY', state: 'Wyoming'}
			];
			var shipping_state_val_set = false;
			var billing_state_val_set = false;
			for(var i = 0; i < us_states.length; i ++)
			{
				if(us_states[i]['code'] == cart.shipToState || us_states[i]['state'] == cart.shipToState)
				{
					shipping_state_val_set = true;
					$j('[name=shippingstate]').val(us_states[i]['state']);
				}
				if(us_states[i]['code'] == cart.billToState || us_states[i]['state'] == cart.billToState)
				{
					billing_state_val_set = true;
					$j('[name=billingstate]').val(us_states[i]['state']);
				}
			}
			if(!shipping_state_val_set)
			{
				$j('[name=shippingstate]').val(cart.shipToState);
			}
			if(!billing_state_val_set)
			{
				$j('[name=billingstate]').val(cart.billToState);
			}
			
			// shipping
			
			$j('[name=shippingfirstname]').val(cart.shipToFirstName);
			$j('[name=shippinglastname]').val(cart.shipToLastName);
			$j('[name=email]').val(cart.email);
			$j('[name=shippingaddress1]').val(cart.shipToAddress1);
			$j('[name=shippingaddress2]').val(cart.shipToAddress2);
			if(cart.shipToCountry)
			{
				$j('[name=shippingcountry]').val(cart.shipToCountry);
			}
			$j('[name=shippingcity]').val(cart.shipToCity);
			$j('[name=shippingpostalcode]').val(cart.shipToPostalCode);
			$j('[name=shippingdayphone]').val(cart.shipToPhone);
			
			// billing
			
			$j('[name=billingfirstname]').val(cart.billToFirstName);
			$j('[name=billinglastname]').val(cart.billToLastName);
			$j('[name=billingaddress1]').val(cart.billToAddress1);
			$j('[name=billingaddress2]').val(cart.billToAddress2);
			if(cart.billToCountry)
			{
				$j('[name=billingcountry]').val(cart.billToCountry);
			}
			$j('[name=billingcity]').val(cart.billToCity);
			$j('[name=billingpostalcode]').val(cart.billToPostalCode);
			
			// credit card
			
			$j('[name=creditcardtype]').val(cart.creditCardType);
			$j('[name=creditcardnumber]').val(cart.creditCardNumber);
			$j('[name=creditcardexpmonth]').val(cart.creditCardExpirationMonth);
			$j('[name=creditcardexpyear]').val(cart.creditCardExpirationYear);
			$j('[name=securitycode]').val(cart.creditCardVerificationNumber);
		}
		catch(e)
		{
			handle_error('complete_form_fields()', e);
		}
	}
	
	
	
	
	
	// capture form fields
	
	function capture_form_fields()
	{
		try
		{
			// set static information
			
			cart.paymentMethod = PAYMENT_METHOD_CREDIT_CARD;
			
			// shipping
			
			cart.shipToFirstName = $j('[name=shippingfirstname]').val();
			cart.shipToLastName = $j('[name=shippinglastname]').val();
			cart.email = $j('[name=email]').val();
			cart.shipToAddress1 = $j('[name=shippingaddress1]').val();
			cart.shipToAddress2 = $j('[name=shippingaddress2]').val();
			cart.shipToCountry = $j('[name=shippingcountry]').val();
			cart.shipToCity = $j('[name=shippingcity]').val();
			cart.shipToState = $j('[name=shippingstate]').val();
			cart.shipToPostalCode = $j('[name=shippingpostalcode]').val();
			cart.shipToPhone = $j('[name=shippingdayphone]').val();
			
			// billing
			if($j('[name=billingsameasshipping]')[0].checked == true)
			{
				cart.billToFirstName = cart.shipToFirstName;
				cart.billToLastName = cart.shipToLastName;
				cart.billToAddress1 = cart.shipToAddress1;
				cart.billToAddress2 = cart.shipToAddress2;
				cart.billToCountry = cart.shipToCountry;
				cart.billToCity = cart.shipToCity;
				cart.billToState = cart.shipToState;
				cart.billToPostalCode = cart.shipToPostalCode;
				cart.billToDayPhone = cart.shipToPhone;
			}
			else
			{
				cart.billToFirstName = $j('[name=billingfirstname]').val();
				cart.billToLastName = $j('[name=billinglastname]').val();
				cart.billToAddress1 = $j('[name=billingaddress1]').val();
				cart.billToAddress2 = $j('[name=billingaddress2]').val();
				cart.billToCountry = $j('[name=billingcountry]').val();
				cart.billToCity = $j('[name=billingcity]').val();
				cart.billToState = $j('[name=billingstate]').val();
				cart.billToPostalCode = $j('[name=billingpostalcode]').val();
				cart.billToDayPhone = $j('[name=billingdayphone]').val();
			}
			
			// credit card
			
			cart.creditCardType = $j('[name=creditcardtype]').val();
			cart.creditCardNumber = $j('[name=creditcardnumber]').val();
			cart.creditCardExpirationMonth = $j('[name=creditcardexpmonth]').val();
			cart.creditCardExpirationYear = $j('[name=creditcardexpyear]').val();
			cart.creditCardVerificationNumber = $j('[name=securitycode]').val();
			
			// update cart
			
			updateCart();
		}
		catch(e)
		{
			handle_error('capture_form_fields()', e);
		}
	}
	
	
	
	
	
	// list shipping options
	
	function list_shipping_options()
	{
		try
		{
			estimateShipping({
				'async': true,
				'onComplete': function(methods)
				{
					if(methods !== null && methods.length > 0)
					{
						var data = {};
						data.methods = [];
						data.currentShippingMethodName = cart.shippingMethod;
						if(cart.shippingHandling == 0.00)
						{
							for(var i = 0; i < methods.length; i ++)
							{
								if(methods[i].name == cart.shippingMethod)
								{
									set_shipping_option(methods[i].name, methods[i].cost);
								}
							}
						}
						for(var i = 0; i < methods.length; i ++)
						{
							data.methods.push({
								name: methods[i].name,
								cost: methods[i].cost.toFixed(2)
							});
						}
						$j('#j_shipping_options').setTemplate($j('#shipping_options_template').val().replace('<!--', '').replace('-->', ''), null, {filter_data: false});
						$j('#j_shipping_options').processTemplate(data);
						$j('[name=shipping_options]').click(function(){
							set_shipping_option($j(this).val(), $j(this).attr('alt'));
						});
					}
				}
			});
		}
		catch(e)
		{
			handle_error('list_shipping_options()', e);
		}
	}
	
	
	
	
	
	// capture form fields and estimate / list shipping options
	
	function capture_form_and_list_shipping()
	{
		try
		{
			capture_form_fields();
			list_shipping_options();
			display_cart_totals();
		}
		catch(e)
		{
			handle_error('capture_form_and_list_shipping()', e);
		}
	}
	
	
	
	
	
	// display cart totals
	
	function display_cart_totals()
	{
		try
		{
			var data = {};
			data.subtotal = cart.subtotal.toFixed(2);
			data.shippingHandling = cart.shippingHandling.toFixed(2);
			data.tax = cart.tax.toFixed(2);
			data.total = cart.total.toFixed(2);
			if(cart.items !== null && cart.items.length > 0)
			{
				$j('#j_totals_wrap').setTemplate($j('#j_totals_template').val().replace('<!--', '').replace('-->', ''), null, {filter_data: false});
				$j('#j_totals_wrap').processTemplate(data);
			}
		}
		catch(e)
		{
			handle_error('display_cart_totals()', e);
		}
	}
	
	
	
	
	
	// set shipping option
	
	function set_shipping_option(methodName, cost)
	{
		try
		{
			cart.shippingMethod = methodName;
			cart.shippingHandling = cost;
			updateCart();
			display_cart_totals();
		}
		catch(e)
		{
			handle_error('set_shipping_option()', e);
		}
	}
	
	
	
	
	
	// attempt order
	
	function attempt_order()
	{
		var errors = validateAll();
		if(errors !== null && errors.length > 0)
		{
			display_cart_errors(errors);
		}
		else
		{
			if(secureHostName)
			{
				var handoffResult = checkoutHandoffOnCustomSSL(secureHostName, returnOnErrorUrl, "error");
			}
			else
			{
				var handoffResult = checkoutHandoff(returnOnErrorUrl, "error");
			}
			if(handoffResult.errors != null && handoffResult.errors.length == 0)
			{
				window.location = handoffResult.redirectToUrl;
			}
			else
			{
				display_cart_errors(handoffResult.errors);
			}
		}
	}




});
